package com.zhentao.service.impl;

import com.zhentao.pojo.Message;
import com.zhentao.util.OrderNumberGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.annotation.KafkaListeners;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

/**
 * @author "杨旭朋"
 * @ClassName: MseeageServiceImpl
 * @date 2025年05月16日 10:45
 */
@Service
public class MseeageServiceImpl {
    @Autowired
    private KafkaTemplate<String,String> kafkaTemplate;
    @Scheduled(cron = "0 * * * * ?")
    public void send(){
        Message message = new Message();
        message.setMsgId(1);
        message.setMsgType("type");
        message.setContent(OrderNumberGenerator.generateOrderNumber().toString());
        kafkaTemplate.send("topic" ,message.getMsgId()+" "+message.getMsgType()+" "+message.getContent());
    }
    @KafkaListener(topics = "topic")
    public void receive(String msg){
        System.out.println("接收到消息："+msg);
    }
}
