package com.zhentao.text;


import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;
import java.util.UUID;

public class TestClient {
    private static final String APP_ID="hch";
    private static final String APP_SECRET = "123";
    private static final String API_URL = "http://localhost:9527/goods/find";
    public static void main(String[] args) {
        String reqId= UUID.randomUUID().toString();
        Long reqTime=System.currentTimeMillis();

        String sign=generateSign(1,reqId,reqTime,APP_ID);
        String result=sendRequest(1,reqId,reqTime,APP_ID,sign);
        System.out.println(result);
    }

    private static String sendRequest(Integer gooseId, String reqId, Long reqTime, String appId, String sign) {
        Map<String,Object>map=new HashMap<>();
        map.put("gooseId",gooseId);
        HttpResponse httpResponse= HttpRequest.get(API_URL).header("reqId",reqId).header("reqTime", String.valueOf(reqTime)).header("appId",appId).header("sign",sign).form(map).execute();
        System.out.println(sign);
        return httpResponse.body();
    }

    private static String generateSign(Integer gooseId, String reqId, Long reqTime, String appId) {
        Map<String,Object>map=new TreeMap<>();
        map.put("gooseId",gooseId);
        map.put("reqId",reqId);
        map.put("reqTime",reqTime);
        map.put("appId",appId);
        StringBuilder sign=new StringBuilder();
        for (Map.Entry<String,Object> m: map.entrySet()) {
            sign.append(m.getKey()).append("=").append(m.getValue()).append("&");
        }
        sign.append("key").append(APP_SECRET);
        return md5(sign.toString());
    }

    private static String md5(String sign) {
        try {
            MessageDigest md5=MessageDigest.getInstance("MD5");
            byte[] digest=md5.digest(sign.getBytes());
            StringBuilder hexString=new StringBuilder();
            for (byte b: digest) {
                String hex=String.format("%02x",b);
                hexString.append(hex);
            }
            return hexString.toString();
        }catch (NoSuchAlgorithmException e){
            throw new RuntimeException(e);
        }
    }
}
