package com.zhentao.util;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;
import java.util.concurrent.atomic.AtomicInteger;

public class OrderNumberGenerator {

    private static final AtomicInteger SEQUENCE = new AtomicInteger(1);
    private static final int MAX_SEQUENCE = 9999;
    private static final Random RANDOM = new Random();
    private static final String ORDER_PREFIX = "SS";

    /**
     * 生成格式化订单号
     * 格式: ORD + 年月日 + 6位随机数 + 4位序列号
     * 示例: ORD202505151234560001
     */
    public static synchronized String generateOrderNumber() {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyyMMdd");
        String datePart = dateFormat.format(new Date());

        // 生成6位随机数
        int randomNum = 100000 + RANDOM.nextInt(900000);

        // 获取序列号并递增
        int seq = SEQUENCE.getAndIncrement();
        if (seq >= MAX_SEQUENCE) {
            SEQUENCE.set(1);
            seq = 1;
        }

        // 组合订单号
        return ORDER_PREFIX + datePart + randomNum + String.format("%04d", seq);
    }
}  